from loonybin import Tool

class Combine(Tool):
    
    def getName(self):
        return 'Machine Translation/Output/Extract Top Best (Joshua)'
    
    def getDescription(self):
        return "Extracts the top-best hypotheses from a Joshua n-best list."
    
    def getRequiredPaths(self):
        return ['joshua-scripts']

    def getParamNames(self):
        return [ ]
    
    def getInputNames(self, params):
        return [ ('nbestIn','Joshua-format n-best list') ]

    def getOutputNames(self, params):
        return [ ('topbestOut', 'top-best hypotheses, one per line') ]
    
    def getCommands(self, params, inputs, outputs):
        return [ ('topbest-josh.py < %(nbestIn)s'%inputs +
                  ' > %(topbestOut)s'%outputs) ]

    def getPostAnalyzers(self, params, inputs, outputs):
        return [ ]

if __name__ == '__main__':
    import sys
    t = Combine()
    t.handle(sys.argv)
