from loonybin import Tool

class TokenizerJoshua(Tool):

    def getName(self):
        return 'Machine Translation/Monolingual Corpus/Tokenizer (Joshua)'

    def getDescription(self):
        return ("Takes an input corpus and tokenize it")

    def getRequiredPaths(self):
        return ["joshua-scripts"]

    def getParamNames(self):
        return [("targetLanguageSuffix", "Two-letter-long suffices specifying the target language. For example, 'en' for English, and 'fr' for French.")]

    def getInputNames(self, params):
        return [("inputCorpus", "An input corpus to be tokenized")]

    def getOutputNames(self, params):
        return [("tokenizedCorpus", "The tokenized input corpus")]

    def getPreAnalyzers(self, params, inputs):
        return ['echo InputCorpusWordCount `wc -w %(inputCorpus)s`'%(inputs),
		'echo InputCorpusLineCount `wc -l %(inputCorpus)s`'%(inputs)]

    def getCommands(self, params, inputs, outputs):
	if params["targetLanguageSuffix"] == '':
	    return ['cat %s | perl ./tokenizer.perl > %s' % (inputs["inputCorpus"], outputs["tokenizedCorpus"])]
	else:
	    return ['cat %s | perl ./tokenizer.perl -l %s > %s' % (inputs["inputCorpus"], params["targetLanguageSuffix"], outputs["tokenizedCorpus"])]

    def getPostAnalyzers(self, params, inputs, outputs):
        return ['echo TokenizedCorpusWordCount `wc -w %(tokenizedCorpus)s`'%(outputs),
		'echo TokenizedCorpusLineCount `wc -l %(tokenizedCorpus)s`'%(outputs)]

if __name__ == '__main__':
    import sys
    t = TokenizerJoshua();
    t.handle(sys.argv)
